

#include "stdafx.h"
#include "ColorText.h"

BEGIN_MESSAGE_MAP(CColorText,CWnd)
	ON_WM_PAINT()
	ON_WM_LBUTTONDOWN()
END_MESSAGE_MAP()

CColorText::CColorText()
{
	m_pFont=NULL;
	m_pArray=NULL;
	
	m_lFontWidth=10;
	m_lFontHeight=16;
	m_lTextColor=0;
	m_lBackColor=7;
	m_lWidth=0;
	m_lHeigth=0;

	m_pColors=new COLORREF[16];
	m_pColors[0]=RGB(0,0,0);
	m_pColors[1]=RGB(0,0,128);
	m_pColors[2]=RGB(128,0,0);
	m_pColors[3]=RGB(0,128,0);
	m_pColors[4]=RGB(128,0,128);
	m_pColors[5]=RGB(0,128,128);
	m_pColors[6]=RGB(128,128,0);
	m_pColors[7]=RGB(128,128,128);
	m_pColors[8]=RGB(160,160,160);
	m_pColors[9]=RGB(0,0,255);
	m_pColors[10]=RGB(255,0,0);
	m_pColors[11]=RGB(0,255,0);
	m_pColors[12]=RGB(255,0,255);
	m_pColors[13]=RGB(0,255,255);
	m_pColors[14]=RGB(255,255,0);
	m_pColors[15]=RGB(255,255,255);
}

CColorText::~CColorText()
{
	if(m_pArray!=NULL) {
		delete [] m_pArray;
	}
	if(m_pFont!=NULL) {
		delete m_pFont;
	}
	delete [] m_pColors;
}

long CColorText::Init(CWnd* pParent, long lX, long lY, long lWidth, long lHeight)
{
	if(m_pFont==NULL) {
		// einen Font generieren
		// FF_MODERN bezeichnet einen fixed Font
		m_pFont=new CFont;
		m_pFont->CreateFont(
			m_lFontHeight,
			m_lFontWidth,
			0,
			0,
			FW_NORMAL,FALSE,FALSE,
			0,
			ANSI_CHARSET,
			OUT_TT_PRECIS,
			CLIP_TT_ALWAYS,
			PROOF_QUALITY,
			FIXED_PITCH|FF_MODERN,
			NULL
		);
	}

	m_pArray=new long [lWidth*lHeight/2+4];
	m_lWidth=lWidth;
	m_lHeigth=lHeight;

	Cls();

	CRect rect;
	rect.left=lX;
	rect.top=lY;
	rect.right=lX+lWidth*m_lFontWidth;
	rect.bottom=lY+lHeight*m_lFontHeight;

	BOOL bCreate;

	bCreate=CWnd::Create(
		NULL,
		NULL,
		WS_CHILD | WS_VISIBLE,
		rect,
		pParent,
		1001,
		NULL
	);

	return 0;
}

void CColorText::SetFontSize(long lWidth, long lHeigth)
{
}

void CColorText::SetFont(CFont* pFont)
{
}

void CColorText::SetTextColor(long lTextColor)
{
	m_lTextColor=lTextColor;
}

void CColorText::SetBackColor(long lBackColor)
{
	m_lBackColor=lBackColor;
}

void CColorText::SetCharacter(long lChar, long lX, long lY)
{
	if(lX<0 || lX>m_lWidth) {
		return;
	}
	if(lY<0 || lY>m_lHeigth) {
		return;
	}

	long lPos=(lX+lY*m_lWidth)/2;
	long lValue;

	if(lX & 0x01 !=0) {
		// ungerade
		lValue=m_pArray[lPos];
		lChar = lChar << 8;
		lValue=lValue & 0xffff00ff;
		lValue=lValue | lChar;
		m_pArray[lPos]=lValue;
	}
	else {
		// gerade
		lValue=m_pArray[lPos];
		lChar = lChar << 24;
		lValue=lValue & 0x00ffffff;
		lValue=lValue | lChar;
		m_pArray[lPos]=lValue;
	}

	CRect rect;
	rect.left=lX*m_lFontWidth;
	rect.top=lY*m_lFontHeight;
	rect.right=rect.left+m_lFontWidth;
	rect.bottom=rect.top+m_lFontHeight;
	InvalidateRect(&rect,FALSE);
}

void CColorText::SetBackground(long lChar, long lX, long lY)
{
	if(lX<0 || lX>m_lWidth) {
		return;
	}
	if(lY<0 || lY>m_lHeigth) {
		return;
	}

	long lPos=(lX+lY*m_lWidth)/2;
	long lValue;

	lChar=lChar & 0x0f;

	if(lX & 0x01 !=0) {
		// ungerade
		lValue=m_pArray[lPos];
		lValue=lValue & 0xfffffff0;
		lValue=lValue | lChar;
		m_pArray[lPos]=lValue;
	}
	else {
		// gerade
		lValue=m_pArray[lPos];
		lChar = lChar << 16;
		lValue=lValue & 0xfff0ffff;
		lValue=lValue | lChar;
		m_pArray[lPos]=lValue;
	}

	CRect rect;
	rect.left=lX*m_lFontWidth;
	rect.top=lY*m_lFontHeight;
	rect.right=rect.left+m_lFontWidth;
	rect.bottom=rect.top+m_lFontHeight;
	InvalidateRect(&rect,FALSE);
}

void CColorText::SetTextColor(long lChar, long lX, long lY)
{
	if(lX<0 || lX>m_lWidth) {
		return;
	}
	if(lY<0 || lY>m_lHeigth) {
		return;
	}

	long lPos=(lX+lY*m_lWidth)/2;
	long lValue;

	lChar=lChar << 4;
	lChar=lChar & 0xf0;

	if(lX & 0x01 !=0) {
		// ungerade
		lValue=m_pArray[lPos];
		lValue=lValue & 0xffffff0f;
		lValue=lValue | lChar;
		m_pArray[lPos]=lValue;
	}
	else {
		// gerade
		lValue=m_pArray[lPos];
		lChar = lChar << 16;
		lValue=lValue & 0xff0fffff;
		lValue=lValue | lChar;
		m_pArray[lPos]=lValue;
	}

	CRect rect;
	rect.left=lX*m_lFontWidth;
	rect.top=lY*m_lFontHeight;
	rect.right=rect.left+m_lFontWidth;
	rect.bottom=rect.top+m_lFontHeight;
	InvalidateRect(&rect,FALSE);
}

long CColorText::GetCharacter(long lX, long lY)
{
	if(lX<0 || lX>m_lWidth) {
		return 0;
	}
	if(lY<0 || lY>m_lHeigth) {
		return 0;
	}

	long lPos=(lX+lY*m_lWidth)/2;
	long lValue;

	if(lX & 0x01 !=0) {
		// ungerade
		lValue=m_pArray[lPos];
		lValue=lValue >> 8;
		lValue=lValue & 0x000000ff;
	}
	else {
		// gerade
		lValue=m_pArray[lPos];
		lValue=lValue >> 24;
		lValue=lValue & 0x000000ff;
	}
	return lValue;
}

long CColorText::GetBackground(long lX, long lY)
{
	if(lX<0 || lX>m_lWidth) {
		return 0;
	}
	if(lY<0 || lY>m_lHeigth) {
		return 0;
	}

	long lPos=(lX+lY*m_lWidth)/2;
	long lValue;

	if(lX & 0x01 !=0) {
		// ungerade
		lValue=m_pArray[lPos];
		lValue=lValue & 0x000000ff;
	}
	else {
		// gerade
		lValue=m_pArray[lPos];
		lValue=lValue >> 16;
		lValue=lValue & 0x000000ff;
	}
	return lValue;
}


void CColorText::Cls()
{
	long lSize;
	long lBG;
	long lTemp;
	long lCount;

	lSize=m_lWidth*m_lHeigth/2;

	lBG=32;
	lBG=lBG << 8;
	lBG=lBG | ( m_lTextColor << 4 | m_lBackColor );

	lTemp=lBG << 16;
	lBG=lBG | lTemp;

	for(lCount=0;lCount<lSize;lCount++) {
		m_pArray[lCount]=lBG;
	}
}

void CColorText::SetText(long lX, long lY, long* plText)
{
	long lRaw;
	long lChar;

	do {
		lRaw=*plText++;
		lChar=lRaw & 0x000000ff;
		if(lChar==0) {
			return;
		}
		SetCharacter(lChar,lX++,lY);
		lChar=lRaw >> 8;
		lChar=lChar & 0x000000ff;
		if(lChar==0) {
			return;
		}
		SetCharacter(lChar,lX++,lY);
		lChar=lRaw >> 16;
		lChar=lChar & 0x000000ff;
		if(lChar==0) {
			return;
		}
		SetCharacter(lChar,lX++,lY);
		lChar=lRaw >> 24;
		lChar=lChar & 0x000000ff;
		if(lChar==0) {
			return;
		}
		SetCharacter(lChar,lX++,lY);
	}
	while(1==1);
}

void CColorText::OnPaint()
{
	CPaintDC dc(this);

	CFont* pFontOld=dc.SelectObject(m_pFont);

	long lX;
	long lY;
	long lBg;
	long lChar;
	long* plBuf=new long[4];
	long lBuf;
	long lTextColor;
	LPCTSTR lpszText=(LPCTSTR)plBuf;


	for(lY=0;lY<m_lHeigth;lY++) {
		for(lX=0;lX<m_lWidth;lX++) {
			lBg=GetBackground(lX,lY);
			dc.SetBkColor(m_pColors[lBg & 0x0f]);
			lTextColor=lBg >> 4;
			lTextColor=lTextColor & 0x0f;
			dc.SetTextColor(m_pColors[lTextColor]);

			lChar=GetCharacter(lX,lY);
			lBuf=lChar;
			lBuf=lBuf & 0x000000ff;
			lBuf=lBuf | 0x00002000;
			*plBuf=lBuf;

			dc.TextOut(lX*m_lFontWidth,lY*m_lFontHeight+4,"  ");
			dc.TextOut(lX*m_lFontWidth,lY*m_lFontHeight,lpszText);
		}
	}


	dc.SelectObject(pFontOld);
	delete [] plBuf;


	CWnd::OnPaint();
}

void CColorText::OnLButtonDown(UINT nFlags, CPoint point) 
{
	long lX=point.x/m_lFontWidth;
	long lY=point.y/m_lFontHeight;

	CWnd* pWnd=GetParent();
	if(pWnd!=NULL) {
		pWnd->PostMessage(WM_MYLBUTTONDOWN,0,lX+lY*256);
	}
	
	CWnd::OnLButtonDown(nFlags, point);
}
