// HexEditDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include <io.h>
#include "HexEdit.h"
#include "GotoDlg.h"
#include "SearchDlg.h"
#include "HexEditDlg.h"

/////////////////////////////////////////////////////////////////////////////
// CHexEditDlg Dialogfeld

CHexEditDlg::CHexEditDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHexEditDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHexEditDlg)
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_lCursorPos=0;
	m_lStartPos=0;
	m_pvFile=NULL;
	m_pvChange=NULL;
	m_lLen=0;
	m_bHex=TRUE;
	m_bFile=FALSE;
	m_strFile="";
	m_lPrevChar=-1;
	m_bChange=FALSE;
	m_strF3Search="";
	m_bF3Hex=TRUE;
	m_bCtrl=FALSE;
	m_dScrollFactor=1;
}

CHexEditDlg::~CHexEditDlg()
{
	if(m_pvFile!=NULL) {
		free(m_pvFile);
	}
	if(m_pvChange!=NULL) {
		free(m_pvChange);
	}
}

void CHexEditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHexEditDlg)
	DDX_Control(pDX, IDC_SCROLLBAR1, m_oScrollBar);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CHexEditDlg, CDialog)
	//{{AFX_MSG_MAP(CHexEditDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(ID_OPTIONS_INSTALL, OnOptionsInstall)
	ON_COMMAND(ID_OPTIONS_UNINSTALL, OnOptionsUninstall)
	ON_COMMAND(ID__ABOUT, OnAbout)
	ON_COMMAND(ID_FILE_EXIT, OnFileExit)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_COMMAND(ID_FILE_SAVEAS, OnFileSaveas)
	ON_COMMAND(ID_EDIT_GOTO, OnEditGoto)
	ON_COMMAND(ID_EDIT_FIND, OnEditFind)
	ON_WM_VSCROLL()
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_WM_MOUSEWHEEL()
	ON_COMMAND(ID_EDIT_COPYWHOLE, OnEditCopyWhole)
	ON_COMMAND(ID_EDIT_COPYHTML, OnEditCopyHTML)
	//}}AFX_MSG_MAP
	ON_WM_ERASEBKGND()
	ON_MESSAGE(WM_MYLBUTTONDOWN, OnMyLButtonDown)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHexEditDlg Nachrichten-Handler

BOOL CHexEditDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
	m_color.SetBackColor(3);
	m_color.Init(this,STARTX,STARTY,SIZEX,SIZEY);

	if(m_lLen!=0) {
		DrawSurface();
	}

	ShowFileLength();
	ShowCurrentPos();
	ShowCurrentFile();
	if(m_lLen!=0) {
		SetScrollBar();
	}
	else {
		m_oScrollBar.EnableWindow(FALSE);
	}
	SetDlgItemText(IDC_STATIC_MODE,"HEX");

	return TRUE;  
}


void CHexEditDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{

/*
		CPaintDC dc(this); // Gertekontext fr Zeichnen
		CRect rect(0,0,400,400);
		CBrush brush;
		brush.CreateSolidBrush(RGB(160,160,0));
		dc.FillRect(&rect,&brush);
*/
		
		CDialog::OnPaint();
	}
}


HCURSOR CHexEditDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


BOOL CHexEditDlg::OnEraseBkgnd( CDC* pDC )
{
	CRect rect;
	m_color.GetWindowRect(&rect);
	rect.right=rect.right-rect.left+STARTX;
	rect.bottom=rect.bottom-rect.top+STARTY;
	rect.top=50;
	rect.left=50;
	pDC->ExcludeClipRect(&rect);
	return CDialog::OnEraseBkgnd(pDC);
}


BOOL CHexEditDlg::PreTranslateMessage(MSG* pMsg) 
{
	if(pMsg->message==WM_KEYUP) {
		if((int)pMsg->wParam==17) {
			// ctrl
			m_bCtrl=FALSE;
		}
	}

	if(pMsg->message==WM_KEYDOWN) {
		switch((int)pMsg->wParam) {
		case 17:
			// ctrl
			m_bCtrl=TRUE;
		break;
		case VK_UP:
			OnKeyUp();
		break;
		case VK_DOWN:
			OnKeyDown();
		break;
		case VK_LEFT:
			OnKeyLeft();
		break;
		case VK_RIGHT:
			OnKeyRight();
		break;
		case VK_TAB:
			OnKeyTab();
		break;
		case 34: // VK_PAGE_DOWN
			OnKeyPageDown();
		break;
		case 33: // VK_PAGE_UP
			OnKeyPageUp();
		break;
		case VK_F3: 
			OnF3();
		break;
		case VK_F4:
			OnEditCopyWhole();
		break;
		case VK_F5:
			OnEditCopyHTML();
		break;
		case 27:
			return CDialog::PreTranslateMessage(pMsg);
		break;
		case 67:
			// 67 = c
			if(m_bCtrl) {
				// Ctrl und C
				OnEditCopy();
				return CDialog::PreTranslateMessage(pMsg);
			}
			// sonst das c normal bearbeiten, also kein break
		default:
			OnChar((long)pMsg->wParam);
			pMsg->wParam=(WPARAM)VK_SPACE;

		}
	}

	return CDialog::PreTranslateMessage(pMsg);
}


// die Lnge einer Datei ermitteln
long CHexEditDlg::GetFileLength(LPCTSTR lpszFile)
{
	FILE* fp=fopen(lpszFile,"rb");
	if(fp) {
		long lFileLength=_filelength(_fileno(fp));
		fclose(fp);
		return lFileLength;
	}
	else {
		return -1;
	}
}

// eine Datei einlesen
BOOL CHexEditDlg::LoadFile(LPCTSTR lpszFile)
{
	long lLen=GetFileLength(lpszFile);
	if(lLen==-1) {
		return FALSE;
	}

	FILE* fp=fopen(lpszFile,"rb");
	if(fp==NULL) {
		return FALSE;
	}

	m_pvFile=calloc(lLen+SIZEHEXX+8,1);
	m_pvChange=calloc(lLen+SIZEHEXX+8/8,1);
	fread(m_pvFile,1,lLen,fp);
	fclose(fp);

	m_lLen=lLen;
	m_strFile=lpszFile;
	if(m_lLen<32768) {
		m_dScrollFactor=1;
	}
	else {
		m_dScrollFactor=32767;
		m_dScrollFactor=m_dScrollFactor/m_lLen;
	}
	return TRUE;
}

BOOL CHexEditDlg::SaveFile()
{
	FILE* fp=fopen(m_strFile,"wb");
	if(fp==NULL) {
		MessageBox("Could not write file.");
		return FALSE;
	}
	fwrite(m_pvFile,1,m_lLen,fp);
	fclose(fp);
	m_bChange=FALSE;
	long l=0;
	for(l=0;l<m_lLen;l++) {
		SetChanged(l,FALSE);
	}
	DrawSurface();
	m_color.Invalidate(FALSE);

	return TRUE;
}



void CHexEditDlg::ShowFileLength()
{
	CString strLen;
	strLen.Format("File length: %ld",m_lLen);
	SetDlgItemText(IDC_STATIC_FILELENGHT,(LPCTSTR)strLen);
}

void CHexEditDlg::ShowCurrentPos()
{
	CString strPos;
	strPos.Format("Current position: %ld",m_lCursorPos+m_lStartPos);
	SetDlgItemText(IDC_STATIC_CURRENTPOSITION,(LPCTSTR)strPos);
}

void CHexEditDlg::ShowCurrentFile()
{
	CString strFileRaw=m_strFile.Mid(m_strFile.ReverseFind('\\')+1);
	CString strFile="File: "+strFileRaw;
	SetDlgItemText(IDC_STATIC_FILE,strFile);
	CString strText="HexEdit - "+strFileRaw;
	SetWindowText(strText);
}


void CHexEditDlg::DrawSurface()
{
	long lLine;
	if(m_lLen==0) {
		return;
	}
	for(lLine=0;lLine<SIZEY;lLine++) {
		DrawLine(lLine);
	}

	Highlight();
}


void CHexEditDlg::Highlight()
{	
	long lCursorX=m_lCursorPos & 0x0000000f;
	long lCursorY=m_lCursorPos / 16;

	if(m_bHex) {
		m_color.SetBackground(11,lCursorX+40,lCursorY);
		m_color.SetBackground(14,lCursorX*2+7,lCursorY);
		m_color.SetBackground(14,lCursorX*2+8,lCursorY);
	}
	else {
		m_color.SetBackground(14,lCursorX+40,lCursorY);
		m_color.SetBackground(11,lCursorX*2+7,lCursorY);
		m_color.SetBackground(11,lCursorX*2+8,lCursorY);
	}

}

void CHexEditDlg::DeHighlight()
{	
	long lCursorX=m_lCursorPos & 0x0000000f;
	long lCursorY=m_lCursorPos / 16;
	m_color.SetBackground(3,lCursorX+40,lCursorY);

	m_color.SetBackground(3,lCursorX*2+7,lCursorY);
	m_color.SetBackground(3,lCursorX*2+8,lCursorY);
}

void CHexEditDlg::DrawLine(long lLine)
{
	long lPos=lLine*SIZEHEXX+m_lStartPos;

	if(lPos>m_lLen) {
		CString strEmpty="                                                          ";
		LPCTSTR lpszOut=(LPCTSTR)strEmpty;
		long* plOut;
		_asm {
			mov edx,lpszOut
			mov plOut,edx
		}

		m_color.SetText(0,lLine,plOut);
		return;
	}
	
	CString strOut;
	CString strHex="";
	CString strLong;
	CString strText;
	long lColumn;
	void* pvLine=m_pvFile;
	void* pvText=calloc(SIZEHEXX+4,1);
	void* pvOut=pvText;
	long lValue;
	long lChar1;
	long lChar2;
	long lChar3;
	long lChar4;

	_asm {
		mov eax,pvLine
		add eax,lPos
		mov pvLine,eax
	}
	for(lColumn=0;lColumn<SIZEHEXX;lColumn=lColumn+4) {
		_asm {
			mov esi,pvLine
			add esi,lColumn
			mov eax,[esi]
			mov lValue,eax
			mov edi,pvOut
			mov [edi],eax
			add edi,4
			mov pvOut,edi
		}
		lChar1=lValue & 0x000000ff;
		lChar2=lValue & 0x0000ff00;
		lChar2=lChar2 >> 8;
		lChar2=lChar2 & 0x000000ff;
		lChar3=lValue & 0x00ff0000;
		lChar3=lChar3 >> 16;
		lChar3=lChar3 & 0x000000ff;
		lChar4=lValue & 0xff000000;
		lChar4=lChar4 >> 24;
		lChar4=lChar4 & 0x000000ff;
		strLong.Format("%02x%02x%02x%02x",lChar1,lChar2,lChar3,lChar4);
		strHex=strHex+strLong;
	}
	
	LPCTSTR lpszText;
	_asm {
		mov edx,pvText
		mov lpszText,edx
	}
	long l;
	char c;
	char* pc=(char*)lpszText;
	for(l=0;l<SIZEHEXX;l++) {
		c=*pc;
		if(c>=0 && c<32) {
			c='.';
			*pc=c;
		}
		pc++;
	}

	CString strLineN;
	strLineN.Format("%06ld",lPos);
	strLineN=strLineN.Right(6);

	if(lPos>m_lLen-SIZEHEXX) {
		long lRest=m_lLen-lPos;
		strHex=strHex.Mid(0,lRest*2)+"                                              ";
		strHex=strHex.Mid(0,SIZEHEXX*2);
		CString strRest=lpszText;
		strRest=strRest.Mid(0,lRest)+"                                   ";
		strRest=strRest.Mid(0,SIZEHEXX);
		strOut.Format("%s:%s:%s",strLineN,strHex,strRest);
	}
	else {
		strOut.Format("%s:%s:%s",strLineN,strHex,lpszText);
	}

	free(pvText);
	LPCTSTR lpszOut=(LPCTSTR)strOut;
	long* plOut;
	_asm {
		mov edx,lpszOut
		mov plOut,edx
	}

	m_color.SetText(0,lLine,plOut);
	
	long l1;
	for(l1=0;l1<SIZEHEXX;l1++) {
		if(IsChanged(lPos+l1)) {
			m_color.SetTextColor(8,l1+40,lLine);
			m_color.SetTextColor(8,l1*2+7,lLine);
			m_color.SetTextColor(8,l1*2+8,lLine);
		}
		else {
			m_color.SetTextColor(0,l1+40,lLine);
			m_color.SetTextColor(0,l1*2+7,lLine);
			m_color.SetTextColor(0,l1*2+8,lLine);
		}
	}
}

void CHexEditDlg::OnKeyUp()
{
	long lPosRaw;
	if(m_lCursorPos<SIZEHEXX && m_lStartPos>=SIZEHEXX) {
		DeHighlight();
		m_lStartPos=m_lStartPos-SIZEHEXX;
		DrawSurface();
		Highlight();
		m_color.Invalidate(FALSE);
		ShowCurrentPos();
		lPosRaw=(long)((double)m_lStartPos*m_dScrollFactor);
		m_oScrollBar.SetScrollPos(lPosRaw & 0xfffffff0,TRUE);
		return;
	}
	if(m_lCursorPos>=SIZEHEXX) {
		DeHighlight();
		m_lCursorPos=m_lCursorPos-SIZEHEXX;
		Highlight();
		m_color.Invalidate(FALSE);
		ShowCurrentPos();
		lPosRaw=(long)((double)m_lStartPos*m_dScrollFactor);
		m_oScrollBar.SetScrollPos(lPosRaw & 0xfffffff0,TRUE);
	}
}

void CHexEditDlg::OnKeyDown()
{
	long lPosRaw;
	if(m_lCursorPos>=(SIZEY-1)*SIZEHEXX && m_lCursorPos+m_lStartPos<m_lLen-SIZEHEXX) {
		DeHighlight();
		m_lStartPos=m_lStartPos+SIZEHEXX;
		DrawSurface();
		Highlight();
		m_color.Invalidate(FALSE);
		ShowCurrentPos();
		lPosRaw=(long)((double)m_lStartPos*m_dScrollFactor);
		m_oScrollBar.SetScrollPos(lPosRaw & 0xfffffff0,TRUE);
		return;
	}
	if(m_lCursorPos+m_lStartPos<m_lLen-SIZEHEXX) {
		DeHighlight();
		m_lCursorPos=m_lCursorPos+SIZEHEXX;
		Highlight();
		m_color.Invalidate(FALSE);
		lPosRaw=(long)((double)m_lStartPos*m_dScrollFactor);
		m_oScrollBar.SetScrollPos(lPosRaw & 0xfffffff0,TRUE);
		ShowCurrentPos();
	}
}

void CHexEditDlg::OnKeyLeft()
{
	long lPosRaw;
	if(m_lCursorPos>0) {
		DeHighlight();
		m_lCursorPos--;
		DrawSurface();
		Highlight();
		m_color.Invalidate(FALSE);
		lPosRaw=(long)((double)m_lStartPos*m_dScrollFactor);
		m_oScrollBar.SetScrollPos(lPosRaw & 0xfffffff0,TRUE);
		ShowCurrentPos();
	}
	if(m_lCursorPos==0 && m_lStartPos>=SIZEHEXX) {
		DeHighlight();
		m_lStartPos=m_lStartPos-SIZEHEXX;
		m_lCursorPos=m_lCursorPos+SIZEHEXX-1;
		DrawSurface();
		Highlight();
		m_color.Invalidate(FALSE);
		lPosRaw=(long)((double)m_lStartPos*m_dScrollFactor);
		m_oScrollBar.SetScrollPos(lPosRaw & 0xfffffff0,TRUE);
		ShowCurrentPos();
	}
}

void CHexEditDlg::OnKeyRight()
{
	long lPosRaw;
	if(m_lCursorPos==SIZEY*SIZEHEXX-1) {
		if(m_lCursorPos+m_lStartPos<m_lLen-1) {
			DeHighlight();
			m_lStartPos=m_lStartPos+SIZEHEXX;
			m_lCursorPos=m_lCursorPos-SIZEHEXX+1;
			DrawSurface();
			Highlight();
			m_color.Invalidate(FALSE);
			ShowCurrentPos();
			lPosRaw=(long)((double)m_lStartPos*m_dScrollFactor);
			m_oScrollBar.SetScrollPos(lPosRaw & 0xfffffff0,TRUE);
		}
		return;
	}
	if(m_lCursorPos+m_lStartPos<m_lLen-1) {
		DeHighlight();
		m_lCursorPos++;
		Highlight();
		m_color.Invalidate(FALSE);
		ShowCurrentPos();
		lPosRaw=(long)((double)m_lStartPos*m_dScrollFactor);
		m_oScrollBar.SetScrollPos(lPosRaw & 0xfffffff0,TRUE);
	}
}

void CHexEditDlg::OnKeyTab()
{
	m_bHex=!m_bHex;
	if(m_bHex) {
		SetDlgItemText(IDC_STATIC_MODE,"HEX");
		DeHighlight();
		Highlight();
		m_color.Invalidate(FALSE);
	}
	else {
		SetDlgItemText(IDC_STATIC_MODE,"ASCII");	
		DeHighlight();
		Highlight();
		m_color.Invalidate(FALSE);
	}

}

void CHexEditDlg::OnKeyPageDown()
{
	long lPosRaw;
	if(m_lCursorPos+m_lStartPos<=m_lLen-SIZEY*SIZEHEXX-1) {
		DeHighlight();
		m_lStartPos=m_lStartPos+SIZEY*SIZEHEXX;
		DrawSurface();
		Highlight();
		m_color.Invalidate(FALSE);
		ShowCurrentPos();
		lPosRaw=(long)((double)m_lStartPos*m_dScrollFactor);
		m_oScrollBar.SetScrollPos(lPosRaw & 0xfffffff0,TRUE);
		return;
	}
}

void CHexEditDlg::OnKeyPageUp()
{
	long lPosRaw;
	if(m_lStartPos>=SIZEY*SIZEHEXX) {
		DeHighlight();
		m_lStartPos=m_lStartPos-SIZEY*SIZEHEXX;
		DrawSurface();
		Highlight();
		m_color.Invalidate(FALSE);
		ShowCurrentPos();
		lPosRaw=(long)((double)m_lStartPos*m_dScrollFactor);
		m_oScrollBar.SetScrollPos(lPosRaw & 0xfffffff0,TRUE);
		return;
	}
	else {
		DeHighlight();
		m_lStartPos=0;
		DrawSurface();
		Highlight();
		m_color.Invalidate(FALSE);
		ShowCurrentPos();
		lPosRaw=(long)((double)m_lStartPos*m_dScrollFactor);
		m_oScrollBar.SetScrollPos(lPosRaw & 0xfffffff0,TRUE);
		return;
	}
}

void CHexEditDlg::OnOptionsInstall() 
{
	HKEY hkSub = NULL;
	DWORD dwDisposition=0;
	LONG lRes;
	if(m_bFile) {
		return;
	}

	CString strRegCommand=GetCommandLine();
	strRegCommand=strRegCommand+" %1";

	
	lRes = RegCreateKeyEx(
			HKEY_CLASSES_ROOT, 
			"*\\shell", 
			0, 
			"KEY", 
			REG_OPTION_NON_VOLATILE,
			KEY_ALL_ACCESS,
			NULL,
			&hkSub,
			&dwDisposition); 

	lRes = RegCreateKeyEx(
			HKEY_CLASSES_ROOT, 
			"*\\shell\\HexEdit", 
			0, 
			"KEY", 
			REG_OPTION_NON_VOLATILE,
			KEY_ALL_ACCESS,
			NULL,
			&hkSub,
			&dwDisposition); 

	lRes = RegCreateKeyEx(
			HKEY_CLASSES_ROOT, 
			"*\\shell\\HexEdit\\command", 
			0, 
			"KEY", 
			REG_OPTION_NON_VOLATILE,
			KEY_ALL_ACCESS,
			NULL,
			&hkSub,
			&dwDisposition); 
	
	
	// if Key Creation/Opening successfull, 
	// write Data into Key
	if(lRes==0)
	{
		RegSetValue(
			hkSub,	// =key
			"",		// Default
			REG_SZ,
			(LPCTSTR)strRegCommand,
			strRegCommand.GetLength()
		);
		MessageBox("Explorer extension (right click\\HexEdit) installed.","HexEdit",MB_ICONINFORMATION|MB_OK);
	}
}

void CHexEditDlg::OnOptionsUninstall() 
{
	RegDeleteKey(
		HKEY_CLASSES_ROOT, 
		"*\\shell\\HexEdit\\command"
	);

	RegDeleteKey(
		HKEY_CLASSES_ROOT, 
		"*\\shell\\HexEdit"
	);

	RegDeleteKey(
		HKEY_CLASSES_ROOT, 
		"*\\shell"
	);

	MessageBox("Explorer extension removed.","HexEdit",MB_ICONINFORMATION|MB_OK);
}

void CHexEditDlg::OnOK() 
{
	return;
}

void CHexEditDlg::OnCancel() 
{
	if(m_bChange) {
		if(MessageBox("Save changes ?","HexEdit",MB_ICONQUESTION|MB_YESNO)==IDYES) {
			if(!SaveFile()) {
				return;
			}
		}
	}
	
	CDialog::OnCancel();
}

void CHexEditDlg::OnChar(long lChar)
{
	lChar=TranslateKey(lChar);
	if(lChar>=0 && lChar<32) {
		return;
	}

	if(m_bHex) {
		if((lChar>='0' && lChar <='9') || (lChar>='a' && lChar<='f') || (lChar>='A' && lChar<='F')) {
			if(lChar>='A' && lChar<='F') {
				lChar=lChar+10-'A';
			}
			if(lChar>='a' && lChar<='f') {
				lChar=lChar+10-'a';
			}
			if(lChar>='0' && lChar<='9') {
				lChar=lChar-'0';
			}
			if(m_lPrevChar==-1) {
				m_lPrevChar=lChar;
			}
			else {
				m_lPrevChar=m_lPrevChar*16+lChar;

				SetCharacter(m_lCursorPos+m_lStartPos,m_lPrevChar);
				SetChanged(m_lCursorPos+m_lStartPos,TRUE);
				DrawSurface();
				OnKeyRight();
				m_lPrevChar=-1;
				m_bChange=TRUE;
			}			
		}
	}
	else {
		SetCharacter(m_lCursorPos+m_lStartPos,lChar);
		SetChanged(m_lCursorPos+m_lStartPos,TRUE);
		DrawSurface();
		OnKeyRight();
		m_lPrevChar=-1;
		m_bChange=TRUE;
	}
}
	

void CHexEditDlg::SetCharacter(long lPos, long lChar)
{
	long lRest=lPos & 0x03;
	long lPattern;

	switch(lRest) {
	case 0:
		lPattern = 0xffffff00;
		lChar=lChar & 0x000000ff;
	break;
	case 1:
		lPattern = 0xffff00ff;
		lChar=lChar << 8;
		lChar=lChar & 0x0000ff00;
	break;
	case 2:
		lPattern = 0xff00ffff;
		lChar=lChar << 16;
		lChar=lChar & 0x00ff0000;
	break;
	case 3:
		lPattern = 0x00ffffff;
		lChar=lChar << 24;
		lChar=lChar & 0xff000000;
	break;
	}

	lPos=lPos & 0xfffffffc ;
	void* pvFile=m_pvFile;
	_asm {
		mov esi,pvFile
		add esi,lPos
		mov eax,[esi]
		and eax,lPattern
		or eax,lChar
		mov [esi],eax
	}
}

long CHexEditDlg::TranslateKey(long lVirtualKey)
{
	UINT uiScan=MapVirtualKey(
		(UINT)lVirtualKey,    
		0
	);

	void* pvKeyState=calloc(260,1);
	PBYTE lpKeyState=(PBYTE)pvKeyState;
	
	GetKeyboardState(
		lpKeyState
	);
	WORD wChar=0;
	int i=ToAscii(
		(UINT)lVirtualKey,
		uiScan,
		lpKeyState,
		&wChar,
		0
		);

	free(pvKeyState);
	return (long)wChar;
}

BOOL CHexEditDlg::IsChanged(long lPos)
{
	long lRest=lPos & 31;
	long lMask=1;
	long lReturn=0;
	lMask=lMask << lRest;
	void* pvChange=m_pvChange;
	lPos=lPos & 0xffffffe0;
	lPos=lPos/8;

	_asm {
		mov esi,pvChange
		add esi,lPos
		mov eax,[esi]
		and eax,lMask
		mov lReturn,eax
	}
	if(lReturn!=0) {
		return TRUE;
	}
	else {
		return FALSE;
	}
}

void CHexEditDlg::SetChanged(long lPos, BOOL bChange)
{
	long lRest=lPos & 31;
	long lMask=1;
	lMask=lMask << lRest;
	void* pvChange=m_pvChange;
	lPos=lPos & 0xffffffe0;
	lPos=lPos/8;

	_asm {
		mov esi,pvChange
		add esi,lPos
		mov eax,[esi]
		or eax,lMask
		mov [esi],eax
	}

	if(bChange==FALSE) {
		_asm {
			mov esi,pvChange
			add esi,lPos
			mov eax,[esi]
			xor eax,lMask
			mov [esi],eax
		}
	}
}

void CHexEditDlg::OnAbout() 
{
	CAboutDlg dlg;dlg.DoModal();	
}

void CHexEditDlg::OnFileExit() 
{
	OnCancel();	
}

void CHexEditDlg::OnFileOpen() 
{
	if(m_lLen!=-1) {
		if(m_bChange) {
			if(!SaveFile()) {
				return;
			}
		}

		m_strFile="";
		free(m_pvFile);
		free(m_pvChange);
		m_pvFile=NULL;
		m_pvChange=NULL;
		m_lLen=-1;
		SetDlgItemText(IDC_STATIC_FILE,"");
		SetDlgItemText(IDC_STATIC_FILELENGHT,"");
		SetDlgItemText(IDC_STATIC_CURRENTPOSITION,"");
		m_lStartPos=0;
		m_lCursorPos=0;
		DeHighlight();
	}

	// File-Dialog erschaffen
	CFileDialog* pmyFileDialog=new CFileDialog(
				TRUE,
				NULL,
				"",
				OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT ,
				"All files (.*)|*.*|",
				NULL
				);
	pmyFileDialog->m_ofn.lpstrTitle="Open file";
	if(pmyFileDialog->DoModal() == IDCANCEL) {
		delete pmyFileDialog;
		return;
	}
	CString strFile=pmyFileDialog->GetPathName();
	delete pmyFileDialog;
	if(!LoadFile(strFile)) {
		MessageBox("Could not open file.","HexEdit",MB_ICONINFORMATION|MB_OK);
		DrawSurface();
		DeHighlight();
		m_color.Invalidate(FALSE);
		return;
	}
	DrawSurface();
	ShowFileLength();
	ShowCurrentPos();
	ShowCurrentFile();
	SetScrollBar();
	m_color.Invalidate(FALSE);
}

void CHexEditDlg::OnFileSave() 
{
	SaveFile();	
}

void CHexEditDlg::OnFileSaveas() 
{
	// File-Dialog erschaffen
	CFileDialog* pmyFileDialog=new CFileDialog(
				FALSE,
				NULL,
				"",
				OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT ,
				"All files (.*)|*.*|",
				NULL
				);
	pmyFileDialog->m_ofn.lpstrTitle="Save file";
	if(pmyFileDialog->DoModal() == IDCANCEL) {
		delete pmyFileDialog;
		return;
	}
	CString strFile=pmyFileDialog->GetPathName();
	delete pmyFileDialog;

	m_strFile=strFile;
	SaveFile();
	ShowCurrentFile();
	
}

void CHexEditDlg::OnEditGoto() 
{
	long lPosRaw;
	CGotoDlg dlg;
	dlg.m_strGoto.Format("%ld",m_lLen-1);
	if(dlg.DoModal()==IDOK) {
		long lPos=atol(dlg.m_strGoto);
		if(lPos>=0 && lPos <m_lLen) {
			DeHighlight();
			m_lStartPos=lPos & 0xfffffff0;
			m_lCursorPos=lPos & 0x0000000f;
			DrawSurface();
			ShowCurrentPos();
			m_color.Invalidate(TRUE);
			lPosRaw=(long)((double)m_lStartPos*m_dScrollFactor);
			m_oScrollBar.SetScrollPos(lPosRaw & 0xfffffff0,TRUE);
		}
	}
}

void CHexEditDlg::OnEditFind() 
{
	long lPosRaw;
	CSearchDlg dlg;
	dlg.m_strSearch=m_strF3Search;
	if(dlg.DoModal()!=IDOK) {
		return;
	}
	
	long lSLen;
	void* pvSearch;
	void* pvFile=m_pvFile;
	BOOL bFree;
	if(dlg.m_iMode==0) {
		// hex
		lSLen=dlg.m_strSearch.GetLength()/2;
		if(lSLen<2) {
			MessageBox("Search must be at least 2 characters.","HexEdit",MB_ICONINFORMATION|MB_OK);
			return;
		}
		pvSearch=Hex2String(dlg.m_strSearch);
		bFree=TRUE;
	}
	else {
		lSLen=dlg.m_strSearch.GetLength();
		if(lSLen<2) {
			MessageBox("Search must be at least 2 characters.","HexEdit",MB_ICONINFORMATION|MB_OK);
			return;
		}
		pvSearch=(void*)(LPCTSTR)dlg.m_strSearch;
		bFree=FALSE;
	}

	// Suche ab der aktuellen Position
	long lCurrent=m_lCursorPos+m_lStartPos+1;
	long lStop=m_lLen-lSLen;
	long lFound=-1;

	_asm {
		mov esi,pvFile
		add esi,lCurrent
		mov edi,pvSearch
		mov ebx,1
		mov edx,pvFile
		add edx,lStop
mainloop:
		mov al,[esi]
		cmp al,[edi]
		jne contsearch
		
		push esi
		push edi
findloop:
		inc esi
		inc edi
		mov al,[esi]
		cmp al,[edi]
		jne notfound
		inc ebx
		cmp ebx,lSLen
		jne findloop
		jmp found
notfound:
		mov ebx,1
		pop edi
		pop esi
contsearch:
		inc esi
		cmp edx,esi
		je finish
		jmp mainloop
found:
		pop edi
		pop edi
		mov eax,esi
		sub eax,lSLen
		sub eax,pvFile
		mov lFound,eax
finish:
	}
	
	m_strF3Search=dlg.m_strSearch;
	if(dlg.m_iMode==0) {
		m_bF3Hex=TRUE;
	}
	else {
		m_bF3Hex=FALSE;
	}

	if(lFound==-1) {
		MessageBox("Not found.","HexEdit",MB_ICONINFORMATION|MB_OK);
	}
	else {
		lFound++;
		DeHighlight();
		m_lStartPos=lFound & 0xfffffff0;
		m_lCursorPos=lFound & 0x0000000f;
		DrawSurface();
		ShowCurrentPos();
		Highlight();
		m_color.Invalidate(TRUE);
		lPosRaw=(long)((double)m_lStartPos*m_dScrollFactor);
		m_oScrollBar.SetScrollPos(lPosRaw & 0xfffffff0,TRUE);
	}
	
	if(bFree) {
		free(pvSearch);
	}
}

void CHexEditDlg::OnF3()
{
	long lPosRaw;
	if(m_strF3Search=="") {
		return;
	}
	long lSLen;
	void* pvSearch;
	void* pvFile=m_pvFile;
	BOOL bFree=m_bF3Hex;
	if(m_bF3Hex) {
		// hex
		lSLen=m_strF3Search.GetLength()/2;
		pvSearch=Hex2String(m_strF3Search);
		bFree=TRUE;
	}
	else {
		lSLen=m_strF3Search.GetLength();
		pvSearch=(void*)(LPCTSTR)m_strF3Search;
		bFree=FALSE;
	}

	// Suche ab der aktuellen Position
	long lCurrent=m_lCursorPos+m_lStartPos+1;
	long lStop=m_lLen-lSLen;
	long lFound=-1;

	_asm {
		mov esi,pvFile
		add esi,lCurrent
		mov edi,pvSearch
		mov ebx,1
		mov edx,pvFile
		add edx,lStop
mainloop:
		mov al,[esi]
		cmp al,[edi]
		jne contsearch
		
		push esi
		push edi
findloop:
		inc esi
		inc edi
		mov al,[esi]
		cmp al,[edi]
		jne notfound
		inc ebx
		cmp ebx,lSLen
		jne findloop
		jmp found
notfound:
		mov ebx,1
		pop edi
		pop esi
contsearch:
		inc esi
		cmp edx,esi
		je finish
		jmp mainloop
found:
		pop edi
		pop edi
		mov eax,esi
		sub eax,lSLen
		sub eax,pvFile
		mov lFound,eax
finish:
	}
	
	if(lFound==-1) {
		MessageBox("Not found.","HexEdit",MB_ICONINFORMATION|MB_OK);
	}
	else {
		lFound++;
		DeHighlight();
		m_lStartPos=lFound & 0xfffffff0;
		m_lCursorPos=lFound & 0x0000000f;
		DrawSurface();
		ShowCurrentPos();
		Highlight();
		m_color.Invalidate(TRUE);
		lPosRaw=(long)((double)m_lStartPos*m_dScrollFactor);
		m_oScrollBar.SetScrollPos(lPosRaw & 0xfffffff0,TRUE);
	}
	
	if(bFree) {
		free(pvSearch);
	}

}


void* CHexEditDlg::Hex2String(LPCTSTR lpszHex)
{
	long lLen=strlen(lpszHex);
	void* pvDest=calloc(lLen,1);
	void* pvCurrent=pvDest;
	long lChar;
	char* pc=(char*)lpszHex;
	char c;

	do {
		c=*pc++;
		if(c==0) {
			break;
		}
		lChar=0;
		if(c>='0' && c<='9') {
			c=c-'0';
		}
		if(c>='a' && c<='f') {
			c=c-'a'+10;
		}
		lChar=c << 4;

		c=*pc++;
		if(c==0) {
			break;
		}
		if(c>='0' && c<='9') {
			c=c-'0';
		}
		if(c>='a' && c<='f') {
			c=c-'a'+10;
		}
		lChar=lChar | c;

		_asm {
			mov esi,pvCurrent
			mov eax,lChar
			mov [esi],al
			inc esi
			mov pvCurrent,esi
		}
	}
	while(1==1);

	return pvDest;
}


void CHexEditDlg::SetScrollBar()
{
	long lLen;
	long lPage;
	if(m_dScrollFactor!=1) {
		lLen=32767;
		lPage=(long)(m_dScrollFactor*640);
	}
	else {
		lLen=m_lLen;
		lPage=640;
	}


	m_oScrollBar.SetScrollPos(0,TRUE);
	SCROLLINFO oScrollInfo;
	m_oScrollBar.SetScrollRange(0,lLen,TRUE);
	oScrollInfo.nMin=0;
	oScrollInfo.nMax=lLen;
	oScrollInfo.nPage=640;
	oScrollInfo.nPos=0;
	oScrollInfo.nTrackPos=0;
	oScrollInfo.fMask=SIF_ALL;
	m_oScrollBar.SetScrollInfo(&oScrollInfo,TRUE);
	if(m_lLen<640) {
		m_oScrollBar.EnableWindow(FALSE);
	}
	else {
		m_oScrollBar.EnableWindow(TRUE);
	}
}

void CHexEditDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// 1,0198892519970951343500363108206
	long lPosRaw;
	long lPos;
	double dPos;
	double dPos2;
	lPosRaw=(long)nPos;
	if(m_dScrollFactor!=1) {
		dPos=(double)lPosRaw;
		dPos=dPos*1.01987;
		dPos2=dPos;
		dPos=dPos*(1/m_dScrollFactor);
		lPos=(long)dPos;
		lPos=lPos & 0xfffffff0;
	}
	else {
		lPos=lPosRaw & 0xfffffff0;
	}
	switch(nSBCode) {
	case SB_THUMBTRACK:

		DeHighlight();
		m_lCursorPos=0;
		m_oScrollBar.SetScrollPos(lPosRaw & 0xfffffff0,TRUE);
		m_lStartPos=lPos;
		DrawSurface();
		Highlight();
		Invalidate(FALSE);
		ShowCurrentPos();

	break;
	case SB_THUMBPOSITION:

		DeHighlight();
		m_lCursorPos=0;
		m_oScrollBar.SetScrollPos(lPosRaw & 0xfffffff0,TRUE);
		m_lStartPos=lPos;
		DrawSurface();
		Highlight();
		Invalidate(FALSE);
		ShowCurrentPos();
		
	break;
	case SB_LINEUP:
		if(m_lStartPos>=SIZEHEXX) {
			DeHighlight();
			m_lCursorPos=0;
			m_lStartPos=m_lStartPos-SIZEHEXX;
			DrawSurface();
//			Highlight();
//			m_color.Invalidate(FALSE);
//			ShowCurrentPos();
//			m_oScrollBar.SetScrollPos(m_lStartPos,TRUE);
			lPosRaw=(long)((double)m_lStartPos*m_dScrollFactor);
			m_oScrollBar.SetScrollPos(lPosRaw & 0xfffffff0,TRUE);
			Highlight();
			Invalidate(FALSE);
			ShowCurrentPos();
		}
	break;
	case SB_LINEDOWN:
		if(m_lStartPos<m_lLen-640) {
			DeHighlight();
			m_lCursorPos=0;
			m_lStartPos=m_lStartPos+SIZEHEXX;
			DrawSurface();
//			Highlight();
//			m_color.Invalidate(FALSE);
//			ShowCurrentPos();
//			m_oScrollBar.SetScrollPos(m_lStartPos,TRUE);
			lPosRaw=(long)((double)m_lStartPos*m_dScrollFactor);
			m_oScrollBar.SetScrollPos(lPosRaw & 0xfffffff0,TRUE);
			Highlight();
			Invalidate(FALSE);
			ShowCurrentPos();
		}
	break;
	case SB_PAGEDOWN:
		if(m_lStartPos<m_lLen-640) {
			DeHighlight();
			m_lCursorPos=0;
			m_lStartPos=m_lStartPos+640;
			DrawSurface();
			lPosRaw=(long)((double)m_lStartPos*m_dScrollFactor);
			m_oScrollBar.SetScrollPos(lPosRaw & 0xfffffff0,TRUE);
			Highlight();
			Invalidate(FALSE);
			ShowCurrentPos();
		}
	break;
	case SB_PAGEUP:
		if(m_lStartPos>640) {
			DeHighlight();
			m_lCursorPos=0;
			m_lStartPos=m_lStartPos-640;
			DrawSurface();
			lPosRaw=(long)((double)m_lStartPos*m_dScrollFactor);
			m_oScrollBar.SetScrollPos(lPosRaw & 0xfffffff0,TRUE);
			Highlight();
			Invalidate(FALSE);
			ShowCurrentPos();
		}
	break;
	}

	
	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}

LRESULT CHexEditDlg::OnMyLButtonDown(WPARAM wParam, LPARAM lParam)
{
	long lX=lParam & 0xff;
	long lY=lParam / 256;
	// X 7-38 = Hex
	// Y 0-39 = Hex
	// X 40-55 = ASCII
	long lPos;


	if(lX>=7 && lX<=38) {
		// Klick auf Hexfeld
		lPos=(lX-7)/2+lY*16;
		if(lPos+m_lStartPos<m_lLen) {
			DeHighlight();
			m_lCursorPos=lPos;
			SetDlgItemText(IDC_STATIC_MODE,"HEX");
			m_bHex=TRUE;
			Highlight();
			m_color.Invalidate(FALSE);
		}
	}
	if(lX>=40 && lX<=55) {
		// Klick auf ACSIIFeld
		lPos=lX-40+lY*16;
		if(lPos+m_lStartPos<m_lLen) {
			DeHighlight();
			m_lCursorPos=lPos;
			SetDlgItemText(IDC_STATIC_MODE,"ASCII");	
			m_bHex=FALSE;
			Highlight();
			m_color.Invalidate(FALSE);
		}
	}

	return 1;
}

void CHexEditDlg::OnEditCopy() 
{
	long lX;
	long lY;
	long lC;
	char cc;
	CString strText="";
	CString strC;
	for(lY=0;lY<40;lY++) {
		for(lX=0;lX<56;lX++) {
			lC=m_color.GetCharacter(lX,lY);
			lC=lC & 0x000000ff;
			cc=(char)lC;
			strC=cc;
			strText=strText+strC;
		}
		strText=strText+"\15\12";
	}
	// 2320;
	HGLOBAL hMem;
	LPVOID pvMem;
	hMem=GlobalAlloc(
		GMEM_MOVEABLE|GMEM_ZEROINIT,
		2340
		);
	if(hMem==NULL) {
		return;
	}
	pvMem=GlobalLock(hMem);
	if(pvMem==NULL) {
		GlobalFree(hMem);
		return;
	}
	strncpy((char*)pvMem,(LPCTSTR)strText,2320);
	GlobalUnlock(hMem);


	OpenClipboard();
	EmptyClipboard();
	SetClipboardData(
		CF_TEXT,
		hMem
		);
	CloseClipboard();
}

BOOL CHexEditDlg::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) 
{
	long lPosRaw;
	// runter -120
	// rauf 120
	if(zDelta<0) {
		// runter
		if(m_lCursorPos+m_lStartPos<m_lLen-48) {
			DeHighlight();
			m_lStartPos=m_lStartPos+48;
			DrawSurface();
			Highlight();
			m_color.Invalidate(FALSE);
			ShowCurrentPos();
			lPosRaw=(long)((double)m_lStartPos*m_dScrollFactor);
			m_oScrollBar.SetScrollPos(lPosRaw & 0xfffffff0,TRUE);
		}
	}
	if(zDelta>0) {
		// rauf
		if(m_lStartPos>=48) {
			DeHighlight();
			m_lStartPos=m_lStartPos-48;
			DrawSurface();
			Highlight();
			m_color.Invalidate(FALSE);
			ShowCurrentPos();
			lPosRaw=(long)((double)m_lStartPos*m_dScrollFactor);
			m_oScrollBar.SetScrollPos(lPosRaw & 0xfffffff0,TRUE);
		}
		else {
			DeHighlight();
			m_lStartPos=0;
			DrawSurface();
			Highlight();
			m_color.Invalidate(FALSE);
			ShowCurrentPos();
			lPosRaw=(long)((double)m_lStartPos*m_dScrollFactor);
			m_oScrollBar.SetScrollPos(lPosRaw & 0xfffffff0,TRUE);
		}
	}
	
	return CDialog::OnMouseWheel(nFlags, zDelta, pt);
}

// den gesamten Hexdump in das Clipboard kopieren
void CHexEditDlg::OnEditCopyWhole() 
{
	long lLine;
	long lY;
	if(m_lLen==0) {
		return;
	}
	CString strOut="";
	lLine=m_lLen/16+1;
	for(lY=0;lY<lLine;lY++) {
		strOut=strOut+DrawTextLine(lY,FALSE)+"\15\12";
	}

	HGLOBAL hMem;
	LPVOID pvMem;
	long lStrLen=strOut.GetLength();
	hMem=GlobalAlloc(
		GMEM_MOVEABLE|GMEM_ZEROINIT,
		lStrLen+20
		);
	if(hMem==NULL) {
		return;
	}
	pvMem=GlobalLock(hMem);
	if(pvMem==NULL) {
		GlobalFree(hMem);
		return;
	}
	strncpy((char*)pvMem,(LPCTSTR)strOut,lStrLen);
	GlobalUnlock(hMem);


	OpenClipboard();
	EmptyClipboard();
	SetClipboardData(
		CF_TEXT,
		hMem
		);
	CloseClipboard();
}

// den gesamten Hexdump als HTML-Quellcode in das Clipboard kopieren
void CHexEditDlg::OnEditCopyHTML() 
{
	long lLine;
	long lY;
	if(m_lLen==0) {
		return;
	}
	CString strFile=m_strFile;
	CString strOut;
	strOut.Format(
		"<html>\15\12"
		"<head></head>\15\12"
		"<body bgcolor=#ffffff>\15\12"
		"<font face=\"courier new\" size=3>\15\12"
		"File: <q>%s</q><br>\15\12"
		"<br>\15\12",
		strFile
		);

	
		
		
	lLine=m_lLen/16+1;
	for(lY=0;lY<lLine;lY++) {
		strOut=strOut+DrawTextLine(lY,TRUE)+"<br>\15\12";
	}
	strOut=strOut+
		"</font>\15\12"
		"</body>\15\12"
		"</html>\15\12";

	HGLOBAL hMem;
	LPVOID pvMem;
	long lStrLen=strOut.GetLength();
	hMem=GlobalAlloc(
		GMEM_MOVEABLE|GMEM_ZEROINIT,
		lStrLen+20
		);
	if(hMem==NULL) {
		return;
	}
	pvMem=GlobalLock(hMem);
	if(pvMem==NULL) {
		GlobalFree(hMem);
		return;
	}
	strncpy((char*)pvMem,(LPCTSTR)strOut,lStrLen);
	GlobalUnlock(hMem);


	OpenClipboard();
	EmptyClipboard();
	SetClipboardData(
		CF_TEXT,
		hMem
		);
	CloseClipboard();	
}


// eine Zeile fr Hexdump im Clipboard zeichnen
CString CHexEditDlg::DrawTextLine(long lLine, BOOL bHTML)
{
	long lPos=lLine*SIZEHEXX;

	if(lPos>m_lLen) {
		CString strEmpty="                                                          ";
		return strEmpty;
	}
	
	CString strOut;
	CString strHex="";
	CString strLong;
	CString strText;
	long lColumn;
	void* pvLine=m_pvFile;
	void* pvText=calloc(SIZEHEXX+4,1);
	void* pvOut=pvText;
	long lValue;
	long lChar1;
	long lChar2;
	long lChar3;
	long lChar4;

	_asm {
		mov eax,pvLine
		add eax,lPos
		mov pvLine,eax
	}
	for(lColumn=0;lColumn<SIZEHEXX;lColumn=lColumn+4) {
		_asm {
			mov esi,pvLine
			add esi,lColumn
			mov eax,[esi]
			mov lValue,eax
			mov edi,pvOut
			mov [edi],eax
			add edi,4
			mov pvOut,edi
		}
		lChar1=lValue & 0x000000ff;
		lChar2=lValue & 0x0000ff00;
		lChar2=lChar2 >> 8;
		lChar2=lChar2 & 0x000000ff;
		lChar3=lValue & 0x00ff0000;
		lChar3=lChar3 >> 16;
		lChar3=lChar3 & 0x000000ff;
		lChar4=lValue & 0xff000000;
		lChar4=lChar4 >> 24;
		lChar4=lChar4 & 0x000000ff;
		strLong.Format("%02x%02x%02x%02x",lChar1,lChar2,lChar3,lChar4);
		if(!bHTML) {
			strHex=strHex+strLong;
		}
		else {
			if(lColumn==0 || lColumn==8) {
				strHex=
					strHex+
					"</font><font face=\"courier new\" size=3 color=#0000ff>"+
					strLong+
					" ";
			}
			else {
				strHex=
					strHex+
					"</font><font face=\"courier new\" size=3 color=#8080ff>"+
					strLong+
					" ";
			}
		}
	}
	
	LPCTSTR lpszText;
	_asm {
		mov edx,pvText
		mov lpszText,edx
	}
	long l;
	char c;
	char* pc=(char*)lpszText;
	for(l=0;l<SIZEHEXX;l++) {
		c=*pc;
		if(c>=0 && c<32) {
			c='.';
			*pc=c;
		}
		pc++;
	}

	CString strLineN;
	CString strHTMLText;
	strLineN.Format("%06ld",lPos);
	strLineN=strLineN.Right(6);

	if(lPos>m_lLen-SIZEHEXX) {
		long lRest=m_lLen-lPos;
		if(!bHTML) {
			strHex=strHex.Mid(0,lRest*2)+"                                              ";
			strHex=strHex.Mid(0,SIZEHEXX*2);
		}
		CString strRest=lpszText;
		strRest=strRest.Mid(0,lRest)+"                                   ";
		strRest=strRest.Mid(0,SIZEHEXX);
		if(!bHTML) {
			strOut.Format("%s:%s:%s",strLineN,strHex,strRest);
		}
		else {
			strRest.Replace("<","&lt;");
			strRest.Replace(">","&gt;");
			strOut.Format(
				"%s :%s :" /*"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;:"*/
				"</font><font face=\"courier new\" size=3 color=#ff0000>"
				"<q>%s</q>"
				"</font><font face=\"courier new\" size=3 color=#000000>",
				strLineN,
				strHex,
				strRest
				);
		}
	}
	else {
		if(!bHTML) {
			strOut.Format("%s:%s:%s",strLineN,strHex,lpszText);
		}
		else {
			strHTMLText=lpszText;
			strHTMLText.Replace("<","&lt;");
			strHTMLText.Replace(">","&gt;");
			strOut.Format(
				"%s :%s:"
				"</font><font face=\"courier new\" size=3 color=#ff0000>"
				"<q>%s</q>"
				"</font><font face=\"courier new\" size=3 color=#000000>",
				strLineN,
				strHex,
				strHTMLText
				);
		}
	}

	free(pvText);
	return strOut;
}
