
#pragma once

#include "ColorText.h"
#include "AboutDlg.h"

#define STARTX 20
#define STARTY 24
#define SIZEX 60
#define SIZEY 40
#define SIZEHEXX 16


class CHexEditDlg : public CDialog
{
public:
	CHexEditDlg(CWnd* pParent = NULL);	
	~CHexEditDlg();	
	void OnKeyUp();
	void OnKeyDown();
	void OnKeyLeft();
	void OnKeyRight();
	void OnKeyTab();
	void OnKeyPageDown();
	void OnKeyPageUp();
	void OnF3();
	void DrawSurface();
	void DrawLine(long lLine);
	void Highlight();
	void DeHighlight();
	void ShowFileLength();
	void ShowCurrentPos();
	void ShowCurrentFile();
	void OnChar(long lChar);
	void SetCharacter(long lPos, long lChar);
	long TranslateKey(long lVirtualKey);
	long GetFileLength(LPCTSTR lpszFile);
	BOOL LoadFile(LPCTSTR lpszFile);
	BOOL IsChanged(long lPos);
	void SetChanged(long lPos, BOOL bChange);
	BOOL SaveFile();
	void* Hex2String(LPCTSTR lpszHex);
	void SetScrollBar();
	CString DrawTextLine(long lLine, BOOL bHTML);
	BOOL m_bFile;

	//{{AFX_DATA(CHexEditDlg)
	enum { IDD = IDD_HEXEDIT_DIALOG };
	CScrollBar	m_oScrollBar;
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CHexEditDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	//}}AFX_VIRTUAL

protected:
	HICON m_hIcon;
	CColorText m_color;
	long m_lCursorPos;
	long m_lStartPos;
	long m_lLen;
	BOOL m_bHex;
	long m_lPrevChar;
	CString m_strFile;
	void* m_pvFile;
	void* m_pvChange;
	BOOL m_bChange;
	CString m_strF3Search;
	BOOL m_bF3Hex;
	BOOL m_bCtrl;
	double m_dScrollFactor;


	//{{AFX_MSG(CHexEditDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnOptionsInstall();
	afx_msg void OnOptionsUninstall();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnAbout();
	afx_msg void OnFileExit();
	afx_msg void OnFileOpen();
	afx_msg void OnFileSave();
	afx_msg void OnFileSaveas();
	afx_msg void OnEditGoto();
	afx_msg void OnEditFind();
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnEditCopy();
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnEditCopyWhole();
	afx_msg void OnEditCopyHTML();
	//}}AFX_MSG
	afx_msg BOOL OnEraseBkgnd( CDC* pDC );
	afx_msg LRESULT OnMyLButtonDown(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

