// SearchDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "HexEdit.h"
#include "SearchDlg.h"

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CSearchDlg 


CSearchDlg::CSearchDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSearchDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSearchDlg)
	m_strSearch = _T("");
	m_iMode = -1;
	//}}AFX_DATA_INIT
}


void CSearchDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSearchDlg)
	DDX_Text(pDX, IDC_EDIT_SEARCH, m_strSearch);
	DDX_Radio(pDX, IDC_RADIO1, m_iMode);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSearchDlg, CDialog)
	//{{AFX_MSG_MAP(CSearchDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CSearchDlg 

void CSearchDlg::OnOK() 
{
	UpdateData(TRUE);
	if(m_strSearch=="") {
		return;
	}
	if(m_iMode==0) {
		long lLen=m_strSearch.GetLength();
		m_strSearch.MakeLower();
		if(lLen & 0x00000001 != 0) {
			MessageBox("Hex string must be of even length.","HexEdit",MB_ICONINFORMATION|MB_OK);
			return;
		}
		if(!IsValidHexString()) {
			MessageBox("Not a valid hex string","HexEdit",MB_ICONINFORMATION|MB_OK);
			return;
		}
	}
	
	CDialog::OnOK();
}

BOOL CSearchDlg::IsValidHexString()
{
	char* pc=(char*)(LPCTSTR)m_strSearch;
	char c;

	do {
		c=*pc++;
		if(c==0) {
			return TRUE;
		}
		if(! ((c>='0' && c<='9') || (c>='a' && c<='f'))) {
			return FALSE;
		}
	}
	while(1==1);
	
	return TRUE;
}

BOOL CSearchDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	GetDlgItem(IDC_RADIO1)->PostMessage(WM_LBUTTONDOWN,0,0);
	GetDlgItem(IDC_RADIO1)->PostMessage(WM_LBUTTONUP,0,0);

	GetDlgItem(IDC_EDIT_SEARCH)->PostMessage(WM_LBUTTONDOWN,0,0);
	GetDlgItem(IDC_EDIT_SEARCH)->PostMessage(WM_LBUTTONUP,0,0);

	return TRUE;
}
